---
title: NDEFReader.write()
slug: Web/API/NDEFReader/write
tags:
  - NDEF
  - Reference
  - Web NFC
---
<p>{{Draft}}{{securecontext_header}}{{SeeCompatTable}}{{APIRef()}}</p>

<p>The <code>write()</code> method of {{DOMxRef("NDEFReader")}} interface writes a specified message to a compatiable NFC tag.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var<em> sessionPromise = NDEFReader</em>.write(<em>message</em>, <em>options</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><span style="display: none;"> </span><code>message</code><span style="display: none;"> </span></dt>
 <dd>The message to be written, either {{DOMxRef("DOMString")}} or {{DOMxRef("BufferSource")}} or {{DOMxRef("NDEFMessageInit")}}.</dd>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>
 <ul>
  <li><code>ignoreRead</code> -- {{JSxRef("Boolean")}} specifying whether or not to skip reading for the activated reader objects. Will be ignored if <code>overwrite</code> is <code>false</code>.</li>
  <li><code>overwrite</code> -- {{JSxRef("Boolean")}} specifying whether or not existing record should be overwritten, if such exists.</li>
  <li><code>signal</code> -- optional {{DOMxRef("AbortSignal")}} that allows to cancell this write operation.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{JSxRef("Promise")}} that resolves with <code>undefined</code> when and if the message transfer is successfully completed.</p>

<h2 id="Exceptions">Exceptions</h2>

<p>This method doesn't throw true exceptions; instead, it rejects the returned promise, passing into it a {{domxref("DOMException")}} whose <code>name</code> is one of the following:</p>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>The write operation was aborted with {{DOMxRef("AbortSignal")}} passed in options.</dd>
 <dt><code>NotAllowedError</code></dt>
 <dd>The permission for this operation was rejected or <code>overwrite</code> is <code>false</code> and there are already records on the tag.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>There is no NFC adapter compatible with Web NFC, or the available NFC adapter does not support pushing messages, or connection can not be established.</dd>
 <dt><code>NotReadableError</code></dt>
 <dd>The UA is not allowed to access underlying NFC adapter (e.g., due to user preference).</dd>
 <dt><code>NetworkError</code></dt>
 <dd>Transfer failed after it already started (e.g., the tag was removed from the reader).</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td><a href="https://w3c.github.io/web-nfc/#dom-ndefreader-write">Web NFC, write()</a></td>
   <td>Draft</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.NDEFReader.write")}}</p>
</div>
